const yargs = require('yargs');
const { generateFeature } = require('./src/generate/feature');

yargs.command({
    command: 'feature',
    describe: 'generate a new feature from the table',
    builder: {
        name: {
            describe: 'Name of the feature in capitalized singular form',
            demandOption: true,
            type: 'string'
        },
        table: {
            describe: 'Name of the table to generate from',
            demandOption: true,
            type: 'string',
        }
    },
    handler: (argv) => {
        generateFeature(argv);
    }
})


yargs.parse();