import {createUseWhereList} from 'api/buildApiHook';
import {pipe, getProp, maybeToAsync} from 'crocks';
import raw from 'raw.macro';


export const useCompanies = createUseWhereList({
    graphQl: raw('./graphql/GetCompanies.graphql'),
    asyncMapFromApi: pipe(
        maybeToAsync('prop \'company\' expected but not found.', getProp('company'))
    ),
    infinite: true,
});
