const fs = require('fs');
const path = require('path');
const {pluralize, titleCase, removeTmpl} = require('../../utils/index');

const settings = {
    path: {
        features: `.${path.sep}src${path.sep}feature${path.sep}`,
        schema: `.${path.sep}schema.graphql`,
        routes: `.${path.sep}Routes.js`
    },
    tmpl: {
        path: './src/generate/feature/templates',
        folders: [
            'api', 
            `api${path.sep}graphql`,
            'form',
            'i18n',
            'layout',
        ],
        files: [
            `api${path.sep}graphql${path.sep}Get{features}.graphql.tmpl`,
            // // `api${path.sep}graphql${path.sep}Get{feature}ByPk.graphql`,
            // // `api${path.sep}graphql${path.sep}Create{feature}.graphql`,
            // // `api${path.sep}graphql${path.sep}Update{feature}ByPk.graphql`,
            // // `api${path.sep}graphql${path.sep}Delete{feature}ByPk.graphql`,
            `api${path.sep}use{features}.js.tmpl`,
            // // `api${path.sep}use{feature}.js`,
            // // `form${path.sep}Edit{feature}Form.js`,
            `i18n${path.sep}en.json.tmpl`,
            `i18n${path.sep}lt.json.tmpl`,
            // // `layout${path.sep}Edit{feature}Layout.js`,
            `layout${path.sep}{features}ListLayout.js.tmpl`,
            `routes.js.tmpl`
        ]
    }
}

// generate feature strcuture
const generateFolders = async (name) => {
    // const mainFolder = settings.path.features + name;
    // await fs.mkdir(mainFolder, (e) => {
    //     if (e) throw e;
        
    //     settings.tmpl.folders.map(async (folder) => {
    //         await fs.mkdir(mainFolder + path.sep + folder, (err) => {
    //             if (err) throw err;
    //         });
    //     });

    //     console.info('1/3 - folders generate successfully!');
    // })
}

// generate files from templates
const generateFiles = async (name, table) => {
    const mainFolder = settings.path.features + name;
    const fields = ['id', 'cid', 'name'];   // TODO: introspect from schema.graphql
    const plural = pluralize(name);

    settings.tmpl.files.map(async (tmpl) => {
        await fs.readFile(settings.tmpl.path + path.sep + tmpl, 'utf-8', async (err, data) => {
            const fileName = removeTmpl(tmpl.replace('{features}', titleCase(plural)));
            const content = data
                .replace(/{{feature}}/g, name)
                .replace(/{{features}}/g, titleCase(plural))
                .replace(/{{table}}/g, table);

            await fs.writeFile(mainFolder + path.sep + fileName, content, (err) => {
                if (err) throw err;
            });
        })
    });
}


const generateFeature = async ({name, table}) => {
    await generateFolders(name);
    await generateFiles(name, table);

    // add to Routes.js
}

module.exports = {
    generateFeature,
}