const pluralize = (word) => {
    if (!word) return '';

    // Irregular nouns with different plural forms
    switch (word) {
        case 'child': return 'children';
        case 'goose': return 'geese';
        case 'man': return 'men';
        case 'mouse': return 'mice';
        case 'person': return 'people';
        case 'tooth': return 'teeth';
        case 'foot': return 'feet';
        case 'ox': return 'oxen';
        case 'louse': return 'lice';
        case 'mouse': return 'mice';
    }

    // Words ending in -s, -x, -z, -ch, -sh
    if (
        word.endsWith('s') ||
        word.endsWith('x') ||
        word.endsWith('z') ||
        word.endsWith('ch') ||
        word.endsWith('sh')
    ) {
        return `${word}es`;
    }

    // Words ending in -y, preceded by a consonant
    if (word.endsWith('y') && /[bcdfghjklmnpqrstvwxyz]/i.test(word[word.length - 2])) {
        return `${word.slice(0, -1)}ies`;
    }

    // Default: add -s to the end
    return `${word}s`;
}


const titleCase = (str) => {
    return str
        .split(' ')
        .map(word => word.charAt(0).toUpperCase() + word.slice(1))
        .join(' ');
}


removeTmpl = (str) => {
    return str.replace('.tmpl', '');
}


module.exports = {
    pluralize,
    titleCase,
    removeTmpl,
}